// This file is part of FreeFinesse, a double-dummy analyzer (c) Ed Colley, 2006
// It is made available under the GPL; see the file COPYING for details

#include "stdafx.h"
#include "dealview_cmdline.h"

// Take note of a change of card state
void DealViewCmdLine::setState(card_t c, const CardState& s)
{
	state[c] = s;
}


// Display the current deal in its current state 
void DealViewCmdLine::displayDeal()
{
	std::string cards[4][4];		// [pl][suit]
	for (int c = 0; c  < 52; c++) {
		suit_t s = suit(c);
		if (state[c].state == CardState::cs_unplayed)
			cards[state[c].player][s] = ranktext(c) + cards[state[c].player][s];
	}
	for (int s = 0; s < 4; s++) for (int pl = 0; pl < 4; pl++) if (cards[pl][s] == "") cards[pl][s] = "none";
	for (int s = 3; s >= 0; s--) out << "\t" << cards[plN][s] << std::endl;
	for (int s = 3; s >= 0; s--) out << cards[plW][s] << "\t\t" << cards[plE][s] << std::endl;
	for (int s = 3; s >= 0; s--) out << "\t" << cards[plS][s] << std::endl;
	for (int c = 0; c < 52; c++) if (state[c].sureTricks != -1) out << cardtext(c) << ": " << state[c].sureTricks << " tricks" << std::endl;
}