// This file is part of FreeFinesse, a double-dummy analyzer (c) Ed Colley, 2006
// It is made available under the GPL; see the file COPYING for details

#include "stdafx.h"
#include "dealview_cmdline.h" 

// Convert a string to a hand
std::vector<card_t> hand(const std::string& str) 
{
	int suit = 3;
	std::vector<card_t> rv;
	for (std::string::const_iterator it = str.begin(); it != str.end(); it++) {
		if (*it == '.') {
			suit--;
		} else {
			size_t p = std::string("23456789TJQKA").find(toupper(*it));
			rv.push_back(card_t(p * 4 + suit));
		}
	}
	return rv;
}


// Main entry point
int main () 
{
	DealController_UI* controller = createDealController();
	deal_t d;
	d.declarer = plS;
	std::string str;
	std::cout << "FreeFinesse by Ed Colley" << std::endl;
	std::cout << "This software is licensed under the GPL" << std::endl;
	std::cout << "See http://sf.net/freefinesse for details" << std::endl;
	std::cout << "South: "; std::cin >> str; d.setCards(plS, hand(str));
	std::cout << "North: "; std::cin >> str; d.setCards(plN, hand(str));
	std::cout << "East:  "; std::cin >> str; d.setCards(plE, hand(str));
	std::cout << "West:  "; std::cin >> str; d.setCards(plW, hand(str));
	std::cout << "Trumps: "; std::cin >> str; d.trumps = suit(str[0]);
	controller->setDeal(d);
	DealViewCmdLine view(std::cin, std::cout);
	controller->addView(&view);
	while (true) {
		controller->analyze(true);
		view.displayDeal();
		std::cout << "Play: ";
		std::string str;
		bool ok = false;
		while (!ok) {
			std::cin >> str;
			ok = controller->clickCard(card(str));
			if (!ok) std::cout << "Invalid play" << std::endl;
		}
	}
	return 0;
}
