// This file is part of FreeFinesse, a double-dummy analyzer (c) Ed Colley, 2006
// It is made available under the GPL; see the file COPYING for details

#include "stdafx.h"

// Hand to string
std::string handtext(const card_t cards[], const bool played[], int count)
{
	std::ostringstream out;
	for (int suit = 3; suit >= 0; suit--) {
		if (suit != 3) out << ".";
		for (int i = 0; i < count; i++) if (((cards[i] & 3) == suit) && !played[i])	out << ranktext(cards[i]);
	}
	return out.str();
}

// Card to string
std::string cardtext(card_t card)
{
	std::ostringstream out;
	out << suittext(card) << ranktext(card);
	return out.str();
}


// Position
void displayPosition(const deal_t& deal, uint64 m)
{
	std::string cards[4][4];		// [pl][suit]
	while (m) {
		uint64 k = lsb(m);
		m ^= k;
		card_t c = bitindex(k);
		int pl = deal.holder(c);
		int s = suit(c);
		cards[pl][s] = ranktext(c) + cards[pl][s];
	}
	for (int s = 0; s < 4; s++) for (int pl = 0; pl < 4; pl++) if (cards[pl][s] == "") cards[pl][s] = "none";
	for (int s = 3; s >= 0; s--) std::cout << "\t" << cards[plN][s] << std::endl;
	for (int s = 3; s >= 0; s--) std::cout << cards[plW][s] << "\t\t" << cards[plE][s] << std::endl;
	for (int s = 3; s >= 0; s--) std::cout << "\t" << cards[plS][s] << std::endl;
}
